<template>
  <div class="app-container">
    <!-- 搜索 -->
    <el-form inline size="mini">
      <el-form-item label="节目Id：">
        <el-input v-model="form.id" placeholder="请输入节目Id" clearable />
      </el-form-item>
      <el-form-item label="节目名称：">
        <el-input v-model="form.name" placeholder="请选择节目名称" clearable />
      </el-form-item>
      <el-form-item label="资源平台：">
        <el-select v-model="form.platformId" placeholder="请选择资源平台" clearable>
          <el-option v-for="item in platformOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="付费类型：">
        <el-select v-model="form.isFree" placeholder="请选择付费类型" clearable>
          <el-option v-for="item in freeOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="当前状态：">
        <el-select v-model="form.status" placeholder="请选择当前状态" clearable>
          <el-option v-for="item in onOrOffOptions" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="getSearch">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="getRefresh">重置</el-button>
        <el-button type="primary" plain icon="el-icon-plus" @click="getDetail()"
          v-hasPermi="['music:program:add']">新增</el-button>
        <el-button type="primary" :disabled="obj.id === ''" @click="getChange(obj, 1)"
          v-hasPermi="['music:program:up']">批量上架</el-button>
        <el-button type="primary" :disabled="obj.id === ''" @click="getChange(obj, 2)"
          v-hasPermi="['music:program:down']">批量下架</el-button>
      </el-form-item>
    </el-form>
    <!-- 列表 -->
    <el-table :data="tableData" v-loading="loading" @selection-change="handleSelect">
      <el-table-column type="selection" align="center" />
      <el-table-column label="节目Id" prop="id" align="center" show-overflow-tooltip />
      <el-table-column label="节目名称" prop="name" align="center" show-overflow-tooltip />
      <el-table-column label="付费类型" prop="isFree" align="center" :formatter="freeFormatter" width="100px" />
      <el-table-column label="原价 / 元" prop="price" align="center" />
      <el-table-column label="折扣价 / 元" prop="discountedPrice" align="center" />
      <el-table-column label="所属专辑" prop="podcastName" align="center" />
      <el-table-column label="资源平台" prop="platformId" align="center" :formatter="platformFormatter" />
      <el-table-column label="当前状态" prop="status" align="center" :formatter="statusFormatter" width="100px" />
      <el-table-column label="更新时间" align="center" show-overflow-tooltip>
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button type="text" @click="getDetail(scope.row.id, true)">查看</el-button>
          <span v-if="scope.row.status === 2">
            <el-button type="text" @click="getDetail(scope.row.id)" v-hasPermi="['music:program:edit']"
              style="margin-left: 10px">编辑</el-button>
            <el-button type="text" @click="getChange(scope.row, 1)" v-hasPermi="['music:program:up']">上架</el-button>
            <el-button type="delete" @click="getDelete(scope.row)" v-hasPermi="['music:program:delete']">删除</el-button>
          </span>
          <el-button type="text" v-else @click="getChange(scope.row, 2)"
            v-hasPermi="['music:program:down']">下架</el-button>
          <Audio :src="scope.row.fullUrl" style="margin-left: 10px" />
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" :page.sync="form.pageNum" :limit.sync="form.pageSize"
      @pagination="getList" />
  </div>
</template>

<script>
import Audio from '@/components/Audio/index.vue'
import { list, change, remove } from '@/api/music/program'
import { platformMixin, onOrOffMixin, isFreeMixin } from '@/mixin/index'
export default {
  mixins: [platformMixin, onOrOffMixin, isFreeMixin],
  components: {
    Audio
  },
  data() {
    return {
      // 遮罩层
      loading: false,
      // 表单
      form: {
        pageNum: 1,
        pageSize: 10
      },
      // 总数据
      total: 0,
      // 列表
      tableData: [],
      // 批量上下架
      obj: {
        id: '',
        name: '已选数据'
      }
    };
  },
  mounted() {
    // 获取资源平台
    this.getPlatform({
      audioType: 6
    })
    this.getList()
  },
  methods: {
    // 列表
    getList() {
      this.loading = true
      list(this.form).then(res => {
        if (res.code === 0) {
          this.tableData = res.data.records
          this.total = res.data.total
          this.loading = false
        }
      })
    },

    // 搜索
    getSearch() {
      this.form.pageNum = 1
      this.getList()
    },

    // 重置
    getRefresh() {
      this.form = {
        pageNum: 1,
        pageSize: 10
      }
      this.getList()
    },

    // 新增 / 查看 / 编辑
    getDetail(id, boolean) {
      this.$router.push({
        path: `/music/program/detail`,
        query: {
          id: id,
          disabled: boolean
        },
      });
    },

    // 上下架
    getChange(row, status) {
      let title = status === 1 ? '上架' : '下架'
      this.$confirm(`是否${title}${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        change(row.id, status).then(res => {
          if (res.code === 0) {
            this.$message.success(`${title}成功！`)
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 删除
    getDelete(row) {
      this.$confirm(`是否删除${row.name}?`, '提示', {
        type: 'warning'
      }).then(() => {
        remove(row.id).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功！')
            this.getList()
          }
        })
      }).catch(() => { })
    },


    // 多选
    handleSelect(e) {
      this.obj.id = ''
      e.map((item, index) => this.obj.id += item.id + ((index + 1) < e.length ? ',' : ''))
    },

    // 字典翻译
    freeFormatter(row) {
      return this.selectDictLabel(this.freeOptions, row.isFree)
    },
    platformFormatter(row) {
      return this.selectDictLabel(this.platformOptions, row.platformId)
    },
    statusFormatter(row) {
      return this.selectDictLabel(this.onOrOffOptions, row.status)
    }
  }
};
</script>